package com.totopia.server.modules.dashboard.repository;

import com.totopia.server.modules.dashboard.entity.DashboardEntity;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;

import java.util.List;

public interface DashboardRepository extends JpaRepository<DashboardEntity, Integer> {
    List<DashboardEntity> findByOrderBySortOrder();

    @Modifying
    @Query("update DashboardEntity d set d.sortOrder = d.sortOrder + 1 where d.sortOrder < :sourceSortOrder and d.sortOrder >= :targetSortOrder")
    int increaseSortOrder(@Param("sourceSortOrder") Integer sourceSortOrder,
            @Param("targetSortOrder") Integer targetSortOrder);

    @Modifying
    @Query("update DashboardEntity d set d.sortOrder = d.sortOrder - 1 where d.sortOrder > :sourceSortOrder and d.sortOrder <= :targetSortOrder")
    int decreaseSortOrder(@Param("sourceSortOrder") Integer sourceSortOrder,
            @Param("targetSortOrder") Integer targetSortOrder);
}
