package com.totopia.server.modules.user.entity;

import com.totopia.server.modules.user.type.GradeName;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import javax.persistence.*;
import java.io.Serializable;

@Entity(name = "grade")
@Data
@NoArgsConstructor
@AllArgsConstructor
@Builder
public class GradeEntity implements Serializable {
    @Id
    @GeneratedValue(generator = "grade_generator")
    @SequenceGenerator(name = "grade_generator", sequenceName = "grade_sequence", initialValue = 1)
    private Short id;

    @Enumerated(EnumType.STRING)
    @Column(name = "name", length = 60)
    private GradeName name;
}
